
package require tile
package require snit
package require tooltip
namespace import -force tooltip::tooltip

namespace eval cu {
    variable topdir [file dirname [info script]]
}

# for tclIndex to work 
proc menubutton_button { args } {}
proc cu::menubutton_button { args } {}
proc cu::menubutton_checkbutton { args } {}
proc cu::combobox { args } {}
proc cu::nicelabel { args } {}
proc cu::dater { args } {}
proc cu::dater_entry { args } {}

interp alias "" menubutton_button "" cu::menubutton_button
interp alias "" nicelabel "" cu::nicelabel


proc cu::init_tile_styles {} {
    variable topdir

    if { [info command wntoolbar_button_bg] eq "" } {
	image create photo wntoolbar_button_bg -file [file join $topdir \
		images wntoolbar_button_bg.gif]
	image create photo wntoolbar_toolbar_bg -file [file join $topdir \
		images wntoolbar_toolbar_bg.gif]
    }

    set err [catch {
	style element create WNtoolbar.background image wntoolbar_toolbar_bg \
	    -border "14 2 2 2" -sticky nsew
    }]
    if { $err } { return }

    style layout WNtoolbar { WNtoolbar.background -sticky nsew -border 1 \
	-expand 1}
    style default WNtoolbar -padding "14 1 1 1"
    
    style element create WNbutton.background image wntoolbar_button_bg \
	-sticky nsew -width 0 -height 0
    
    style layout WNbutton {
	WNbutton.background -sticky nsew
	Toolbutton.border -sticky nswe -children {
	    Toolbutton.padding -sticky nswe -children {
		Toolbutton.label -sticky nswe
	    }
	}
    }
}

snit::widgetadaptor cu::menubutton_button {
    option -command ""
    option -image ""
    option -text ""

    delegate method * to hull
    delegate option * to hull
    delegate option -_image to hull as -image
    delegate option -_text to hull as -text

    constructor args {
	installhull using ttk::menubutton -style Toolbutton
	bind $win <ButtonPress-1> [mymethod BP1 %x %y]
	bind $win <ButtonRelease-1> [mymethod BR1 %x %y]

	$self configurelist $args
    }
    onconfigure -image {img} {
	set options(-image) $img

	if { $img ne "" } {
	    set width [image width $img]
	    set height [image height $img]
	} else { foreach "width height" [list 0 16] break }

	set new_img [image create photo -width [expr {$width+7}] -height $height]
	if { $img ne "" } { $new_img copy $img -to 0 0 }
	set coords {
	    -3 -1
	    -4 -2 -3 -2 -2 -2
	    -5 -3 -4 -3 -3 -3 -2 -3 -1 -3
	}
	foreach "x y" $coords {
	    $new_img put black -to [expr {$width+7+$x}] [expr {$height+$y}]
	}
	$self configure -_image $new_img
	bind $win <Destroy> +[list image delete $new_img]
    }
    onconfigure -text {value} {
	set options(-text) $value

	if { $options(-text) ne "" } {
	    $self configure -style ""
	}
	$self configure -_text $value
    }
    method BP1 { x y } {
	if { $x < [winfo width $win]-10 } {
	    $win instate !disabled {
		tile::clickToFocus $win
		$win state pressed
	    }
	    return -code break
	}
    }
    method BR1 { x y } {
	if { $x < [winfo width $win]-10 } {
	    $win instate {pressed !disabled} {
		$win state !pressed
		uplevel #0 $options(-command)
	    } 
	    return -code break
	}
    }
}

snit::widgetadaptor cu::menubutton_checkbutton {
    option -menu ""
    option -image ""

    delegate method * to hull
    delegate option * to hull
    delegate option -_image to hull as -image

    constructor args {
	installhull using ttk::checkbutton -style Toolbutton
	bind $win <ButtonPress-1> [mymethod BP1 %x %y]
	bind $win <ButtonRelease-1> [mymethod BR1 %x %y]

	$self configurelist $args
    }
    onconfigure -image {img} {
	set options(-image) $img
	set width [image width $img]
	set height [image height $img]
	set new_img [image create photo -width [expr {$width+8}] -height $height]
	$new_img copy $img -to 0 0
	set coords {
	    -3 -1
	    -4 -2 -3 -2 -2 -2
	    -5 -3 -4 -3 -3 -3 -2 -3 -1 -3
	}
	foreach "x y" $coords {
	    $new_img put black -to [expr {$width+6+$x}] [expr {$height+$y}]
	}
	$self configure -_image $new_img
	bind $win <Destroy> +[list image delete $new_img]
    }
    method BP1 { x y } {
	if { $x >= [winfo width $win]-12 } {
	    $win instate !disabled {
		tile::clickToFocus $win
		$win state pressed
		set x [winfo rootx $win]
		set y [expr {[winfo rooty $win]+[winfo height $win]}]
		tk_popup $options(-menu) $x $y
	    }
	    return -code break
	}
    }
    method BR1 { x y } {
	if { $x >= [winfo width $win]-12 } {
	    $win instate {pressed !disabled} {
		$win state !pressed
	    } 
	    return -code break
	}
    }
}


snit::widgetadaptor cu::combobox {
    option -valuesvariable ""
    option -textvariable ""
    option -statevariable ""
    option -values ""
    option -dict ""

    variable _translated_textvariable ""

    delegate method * to hull
    delegate option * to hull
    delegate option -_values to hull as -values
    delegate option -_textvariable to hull as -textvariable

    constructor args {
	installhull using ttk::combobox

	$self configurelist $args
    }
    destructor {
	if { $options(-valuesvariable) ne "" } {
	    upvar #0 $options(-valuesvariable) v
	    trace remove variable v write "[mymethod _changed_values_var];#"
	}
	if { $options(-textvariable) ne "" } {
	    upvar #0 $options(-textvariable) v
	    trace remove variable v write "[mymethod _written_textvariable];#"
	}
	if { $options(-statevariable) ne "" } {
	    upvar #0 $options(-statevariable) v
	    trace remove variable v write "[mymethod _written_statevariable];#"
	    trace remove variable v read "[mymethod _read_statevariable];#"
	}
    }
    onconfigure -textvariable {value} {
	set options(-textvariable) $value
	$self configure -_textvariable [myvar _translated_textvariable]

	upvar #0 $options(-textvariable) v
	trace add variable v write "[mymethod _written_textvariable];#"
	trace add variable [myvar _translated_textvariable] write \
	    "[mymethod _read_textvariable];#"
	if { [info exists v] } {
	    set v $v
	}
    }
     onconfigure -statevariable {value} {
	set options(-statevariable) $value

	upvar #0 $options(-statevariable) v
	trace add variable v write "[mymethod _written_statevariable];#"
	trace add variable v read "[mymethod _read_statevariable];#"
	if { [info exists v] } {
	    set v $v
	}
    }
    onconfigure -valuesvariable {value} {
	set options(-valuesvariable) $value

	upvar #0 $options(-valuesvariable) v
	if { ![info exists v] } {
	    set v ""
	    foreach value [$self cget -_values] {
		catch { 
		    set value [dict get [dict_inverse $options(-dict)] $value]
		}
		lappend v $value
	    }
	} else {
	    set vtrans ""
	    foreach value $v {
		catch { set value [dict get $options(-dict) $value] }
		lappend vtrans $value
	    }
	    $self configure -_values $vtrans
	}
	trace add variable v write "[mymethod _changed_values_var];#"
    }
    onconfigure -values {values} {
	if { $options(-valuesvariable) ne "" } {
	    upvar #0 $options(-valuesvariable) v
	    set v $values
	} else {
	    set vtrans ""
	    foreach value $values {
		catch { set value [dict get $options(-dict) $value] }
		lappend vtrans $value
	    }
	    $self configure -_values $vtrans
	}
    }
    oncget -values {
	set v ""
	foreach value [$self cget -_values] {
#             catch {
#                 set value [dict get [dict_inverse $options(-dict)] $value]
#             }
	    lappend v $value
	}
	return $v
    }
    method _changed_values_var {} {
	upvar #0 $options(-valuesvariable) v
	set vtrans ""
	foreach value $v {
	    catch { set value [dict get $options(-dict) $value] }
	    lappend vtrans $value
	}
	$self configure -_values $vtrans
    }
    method _written_textvariable {} {

	upvar #0 $options(-textvariable) v
	set value $v
	catch { set value [dict get $options(-dict) $value] }
	if { $_translated_textvariable ne $value } {
	    set _translated_textvariable $value
	}
    }
    method _read_textvariable {} {
	upvar #0 $options(-textvariable) v
	set value $_translated_textvariable
	catch {
	    set value [dict get [dict_inverse $options(-dict)] $value]
	}
	if { ![info exists v] || $v ne $value } {
	    set v $value
	}
    }
    method _written_statevariable {} {
	upvar #0 $options(-statevariable) v
	$self state $v
    }
    method _read_statevariable {} {
	upvar #0 $options(-statevariable) v
	set v [$self state]
    }
}

snit::widgetadaptor cu::nicelabel {

    delegate method _insert to hull as insert
    delegate method * to hull
    delegate option * to hull

    constructor args {
	text $self -width 5 -height 1 -bd 0 -insertwidth 0 -spacing3 3 -font "-size 10" \
	    -takefocus 0
	set err [catch { [[winfo parent $self] cget -bg] } bg]
	if { $err } { set bg white }
	$self configure -bg $bg
	installhull $self

	set font [font actual [$self cget -font]]
	set size [expr {[font actual $font -size]+1}]
	set font [font actual $font]
	set ipos [expr {[lsearch $font -size]+1}]
	set font [lreplace $font $ipos $ipos $size]
	$self configure -font $font

	set font [font actual [$self cget -font]]
	set size [expr {[font actual $font -size]-3}]
	set font [font actual $font]
	set ipos [expr {[lsearch $font -size]+1}]
	set font [lreplace $font $ipos $ipos $size]

	set boldfont [font actual [$self cget -font]]
	set ipos [expr {[lsearch $font -weight]+1}]
	set boldfont [lreplace $font $ipos $ipos bold]

	$self tag conf subscript -font $font -offset -3
	$self tag conf superscript -font $font -offset 3
	$self tag conf bold -font $boldfont

	bind $self <1> break
	bind $self <Tab> "[bind all <Tab>] ; break"
	bind $self <<PrevWindow>> "[bind all <<PrevWindow>>] ; break"

	$self configure -state disabled
	$self configurelist $args
    }
    method insert { index txt { tag "" } } {

	if { $index ne "end" } { set index 1.$index }
	$self configure -state normal
	$self _insert $index $txt $tag
    }
}


################################################################################
# cu::dater
################################################################################

snit::widget cu::dater {
    option -font "Verdana 7"
    option -topframecolor "#7b9cc1"
    option -date ""
    option -select_handler ""
    option -events_handler ""
    option -grab 0
    option -detailed_view 0

    hulltype frame

    variable month
    variable year
    variable date_ini ""
    variable date_end ""
    constructor args {

	$self configurelist $args
	set days ""
	set d [clock seconds]
	set daynum [clock format $d -format %u]
	foreach i [rangeF [expr {1-$daynum}] [expr {7-$daynum}]] {
	    set day [clock format [clock scan "$i days" \
		        -base $d] -format %A -locale system]
	    if { $options(-detailed_view) } {
		lappend days $day
	    } else {
		lappend days [string index $day 0]
	    }
	}
	$self create_images

	$hull configure -background black

	frame $win.f -bg $options(-topframecolor)
	label $win.f.l1 -image fletxa-left-16 -padx 2 -pady 1 -bg \
	    $options(-topframecolor)
	frame $win.f.central
	label $win.f.central.l1 -textvariable [myvar month] -bg $options(-topframecolor) \
	    -fg white -font $options(-font)
	label $win.f.central.l2 -textvariable [myvar year] -bg $options(-topframecolor) \
	    -fg white -font $options(-font)
	label $win.f.l3 -image fletxa-right-16 -padx 4 -pady 1 -bg \
	    $options(-topframecolor) -font $options(-font)

	grid $win.f.central.l1 -row 0 -column 0
	grid $win.f.central.l2 -row 0 -column 1

	grid $win.f.l1 -sticky w -row 0 -column 0
	grid $win.f.central -sticky ew -row 0 -column 2 
	grid $win.f.l3 -sticky e -row 0 -column 4
	grid columnconfigure $win.f "1 3" -weight 1
	grid $win.f -columnspan 7 -sticky ew

	bind $win.f.l1 <1> [mymethod configure -date "-1 month"]
	bind $win.f.central.l1 <1> [mymethod contextual month %W %X %Y]
	bind $win.f.central.l2 <1> [mymethod contextual year %W %X %Y]
	bind $win.f.l3 <1> [mymethod configure -date "+1 month"]

	set idx 0
	foreach i $days {
	    label $win.l$idx -text $i -bg white -padx 0 -pady 0 -anchor w \
		-font $options(-font)
	    grid $win.l$idx -row 1 -column $idx -padx 0 -pady 0 -sticky ew
	    incr idx
	}
	ttk::separator $win.s -orient horizontal
	grid $win.s -columnspan 7 -sticky ew

	grid columnconfigure $win 0 -weight 1
	grid rowconfigure $win 3 -weight 1

	$self configurelist $args
	if { $options(-date) eq "" } {
	    $self configure -date ""
	}
    }
    onconfigure -date { value } {
	if { $value eq "" } {
	    set options(-date) [clock format [clock seconds] -format %Y-%m-%d]
	} elseif { [regexp {^[-+]} $value] } {
	    set options(-date) [clock format [clock scan $value -base \
		        [clock scan $options(-date)]] -format %Y-%m-%d]
	} else {
	    set options(-date) $value
	}
	set err [catch { $self _move_to_day }]
	if { $err } { $self fill_days }
    }
    onconfigure -grab { value } {
	set options(-grab) $value
	if { $value } {
	    grab $win
	    bind [winfo toplevel $win] <ButtonRelease-1> \
		[mymethod button_release1 "" %X %Y]
	} else {
	    grab release $win
	    bind [winfo toplevel $win] <ButtonRelease-1> ""
	}
    }
    onconfigure -topframecolor { value } {
	set options(-topframecolor) $value
	foreach w [list $win.f $win.f.l1 $win.f.central.l1 $win.f.central.l2 \
		$win.f.l3] {
	    $w configure -bg $options(-topframecolor)
	}
    }
    onconfigure -font { value } {
	set options(-font) $value

    }
    method select_day { curr_date } {
	if { $options(-select_handler) ne "" } {
	    set cmd $options(-select_handler)
	    lappend cmd $curr_date
	    uplevel #0 $cmd
	}
    }
    method button_release1 { curr_date x y } {
	if { $options(-grab) } {
	    if { $x < [winfo rootx $win] || $y < [winfo rooty $win] ||
		$x > [winfo rootx $win]+[winfo width $win] ||
		$y > [winfo rooty $win]+[winfo height $win] } {
		$self select_day ""
		return -code break
	    }
	}
	$self configure -date $curr_date
    }
    method _move_to_day {} {
	set days [expr {([clock scan $options(-date)]-[clock scan $date_ini])/86400}]
	set idx $days
	set w $win.b$idx
	if { ![winfo exists $w] } {
	    error "error: day is not visualized"
	}
	if { [winfo exists $w.l] } { set w $w.l }
	focus $w
    }
    method fill_days {} {
	
	set month [clock format [clock scan $options(-date)] -format "%B " \
		-locale system]
	set year [clock format [clock scan $options(-date)] -format "%Y"]

	set day1 [clock format [clock scan $options(-date)] -format %Y-%m-01]
	set weekday1 [clock format [clock scan $day1] -format %u]
	set range ""

	if { $weekday1 == 1 } {
	    set minus 7
	} else {
	    set minus [expr {$weekday1-1}]
	}
	set date_ini [clock format [clock scan "-$minus days" -base [clock scan $day1]] \
		    -format "%Y-%m-%d"]
	set d1 [scan [clock format [clock scan "-$minus days" -base [clock scan $day1]] \
		    -format %d] %d]
	set d2 [scan [clock format [clock scan "-1 days" \
		        -base [clock scan $day1]] -format %d] %d]
	eval lappend range [rangeF $d1 $d2]

	set d3 [scan [clock format [clock scan "+1 month -1 days" \
		        -base [clock scan $day1]] -format %d] %d]
	eval lappend range [rangeF 1 $d3]
	set dayend [clock format [clock scan $options(-date)] -format %Y-%m-$d3]
	set weekdayend [clock format [clock scan $dayend] -format %u]
	set date_end [clock format [clock scan "+1 month -1 days" -base [clock scan $day1]] \
		-format "%Y-%m-%d"]

	if { $weekdayend < 7 } {
	    set d4 [scan [clock format [clock scan "+[expr {7-$weekdayend}] days" \
		            -base [clock scan $dayend]] -format %d] %d]
	    eval lappend range [rangeF 1 $d4]
	    set date_end [clock format [clock scan "+[expr {7-$weekdayend}] days" \
		    -base [clock scan $dayend]] -format "%Y-%m-%d"]
	} else { set d4 0 }
	if { [llength $range] <= 35 } {
	    eval lappend range [rangeF [expr {$d4+1}] [expr {$d4+7}]]
	    set date_end [clock format [clock scan "+[expr {7-$weekdayend+7}] days" \
		    -base [clock scan $dayend]] -format "%Y-%m-%d"]
	}
	set date_month [scan [clock format [clock scan $options(-date)] -format %m] %d]
	set date_day [scan [clock format [clock scan $options(-date)] -format %d] %d]
	set today_month [scan [clock format [clock seconds] -format %m] %d]
	set today_day [scan [clock format [clock seconds] -format %d] %d]

	if { $options(-events_handler) ne "" } {
	    set events_dict [uplevel #0 $options(-events_handler) \
		    [list $date_ini $date_end]]
	} else { set events_dict "" }

	set rel_month -1
	set curr_year [scan [clock format [clock scan $date_ini] -format "%Y"] %d]
	foreach "row col idx" [list 3 0 0] break
	foreach i $range {
	    if { $i == 1 } {
		incr rel_month
		set curr_month [expr {$date_month+$rel_month}]
		if { $curr_month > 12 } { incr curr_month -12 }
		if { $curr_month == 1 } { incr curr_year }
	    } else {
		set curr_month [expr {$date_month+$rel_month}]
	    }
	    destroy $win.b$idx

	    if { $options(-detailed_view) } {
		frame $win.b$idx -bg cornsilk2 -bd 0 -takefocus 0 \
		    -width 70 -height 70
		grid propagate $win.b$idx 0
		set label $win.b$idx.l
	    } elseif { $today_month != $curr_month || $today_day != $i } {
		set label $win.b$idx
	    } else {
		frame $win.b$idx -bg brown -bd 0 -takefocus 0
		set label $win.b$idx.l
	    }
	    label $label -text $i -bg white -relief flat -bd 0 \
		-padx 4 -pady 1 -takefocus 1 -font $options(-font)
	    if { $rel_month != 0 } {
		$label configure -fg grey
	    }
	    if { $options(-detailed_view) } {
		$label configure -padx 3 -pady 0 -bg cornsilk2 -font $options(-font)
		grid $label -padx 1 -pady 1 -sticky nw

	    } elseif { $today_month == $curr_month && $today_day == $i } {
		$label configure -padx 3 -pady 0 -font $options(-font)
		grid $label -padx 1 -pady 1
	    } else {
		grid $label -padx 0 -pady 0
	    }
	    
	    grid $win.b$idx -row $row -column $col -padx 0 -pady 0 -sticky nsew
	    grid columnconfigure $win $col -weight 1
	    grid rowconfigure $win $row -weight 1

	    if { $options(-detailed_view) } {
		grid configure $win.b$idx -padx "0 1" -pady "0 1"
	    }

	    set curr_date [format "%04d-%02d-%02d" $curr_year $curr_month $i]
	    if { [dict exists $events_dict $curr_date] } {
		set txtList ""
		foreach i [dict get $events_dict $curr_date] {
		    set txt ""
		    if { [dict exists $i start] } {
		        append txt "[dict get $i start] "
		        append txt "[dict get $i end]\n"
		    }
		    append txt "[dict get $i text]"
		    lappend txtList $txt
		}
		tooltip $label [join $txtList \n]
		if { $options(-detailed_view) } {
		    set jdx 0
		    foreach j $txtList {
		        label $win.b$idx.l$jdx -anchor w -bg cornsilk2 \
		            -font $options(-font)
		        tooltip $win.b$idx.l$jdx $j
		        $win.b$idx.l$jdx configure -text $j
		        grid $win.b$idx.l$jdx -sticky nwe
		        incr jdx
		    }
		    grid columnconfigure $win.b$idx 0 -weight 1
		} else {
		    $label configure -foreground red
		}
	    }

	    bind $label <ButtonRelease-1> [mymethod button_release1 $curr_date %X %Y]
	    bind $label <Double-1> [mymethod select_day $curr_date]
	    bind $label <space> [mymethod select_day $curr_date]
	    bind $label <Return> [mymethod select_day $curr_date]
	    bind $label <Escape> [mymethod select_day ""]
	    bind $label <FocusIn> [list $label configure -bg orange]
	    if { $options(-detailed_view) } {
		bind $label <FocusOut> [list $label configure -bg cornsilk2]
	    } else {
		bind $label <FocusOut> [list $label configure -bg white]
	    }

	    foreach "key d" [list Left "-1day" Right "+1day" Up "-1week" \
		    Down "+1week" Prior "-1month" Next "+1month"] {
		bind $label <Key-$key> [mymethod configure -date $d]
	    }
	    if { $rel_month == 0 && $date_day == $i } { focus $label }
	    
	    incr col
	    if { $col > 6 } {
		set col 0
		incr row
	    }
	    incr idx
	}
	while { [winfo exists $win.b$idx] } {
	    destroy $win.b$idx
	    incr idx
	}
	destroy $win.s2
	ttk::separator $win.s2 -orient horizontal
	grid $win.s2 -columnspan 7 -sticky ew
	
	destroy $win.fb
	frame $win.fb
	ttk::button $win.fb.b -text [_ "Today"] -width 5 -command \
	    [mymethod configure -date [clock format [clock seconds] -format %Y-%m-%d]]
	grid $win.fb.b
	grid $win.fb -columnspan 7 -pady 0 -sticky ew
	grid columnconfigure $win.fb 0 -weight 1
    }
    method contextual { month_year label x y } {

	destroy $label.m
	set menu [menu $label.m -tearoff 0]
	if { $month_year eq "month" } {
	    set m0 [scan [clock format [clock scan $options(-date)] \
		        -format %m] %d]
	    set idx 0
	    foreach m [rangeF 1 12] {
		set date [clock format [clock scan $options(-date)] \
		        -format %Y-$m-%d]
		set name [clock format [clock scan $date] \
		        -format %B -locale system]
		$menu add command -label $name -command [mymethod configure \
		        -date $date]
		if { $m == $m0 } { set entry $idx }
		incr idx
	    }
	} else {
	    set year [scan [clock format [clock scan $options(-date)] \
		        -format %Y] %d]
	    set idx 0
	    foreach ye [rangeF [expr {$year-5}] [expr {$year+5}]] {
		set date [clock format [clock scan $options(-date)] \
		        -format $ye-%m-%d]
		$menu add command -label $ye -command [mymethod configure \
		        -date $date]
		if { $ye == $year } { set entry $idx }
		incr idx
	    }
	}
	$self configure -grab 0
	tk_popup $menu $x $y $entry
	if { $::tcl_platform(platform) != "windows" } {    
	    bind $menu <Unmap> "set ::pp done"
	    vwait ::pp
	}
	after idle [mymethod configure -grab 1]
    }
    method create_images {} {
	if { [lsearch [image names] fletxa-left-16] == -1 } {
	    image create photo fletxa-left-16 -data {
		R0lGODdhEAAQAMQAALW+qI6ZfcPIuJepfZ+whqu7mbbHosvXupWndZutfKCwhqS0iqW3jqKz
		jbbEoZaocZytfKS0i///////////////////////////////////////////////////////
		/ywAAAAAEAAQAAAFryAABuJIkkIwEGAhioYBHqIYBAiSKIqiEAvDNM4RBMgDgYooRgzTOEcQ
		IA80ihLDNM4RBAiSjIoEShLTOEcQIA+kKIokSQzTOEcQIEiiKBIoSQvDNM4RBAiSKJIkEQvD
		NM4RBAiSKKAiSdLCMI1zBAGCJIqiSJLEMI1zBAHygJCiKIokSUzjHEGAPBCoiKLEMI1zBAGC
		JKNCLAzTOEcQDARYiKJhgIcoBgAYiCNJCiEAOw==
	    }

	}
	if { [lsearch [image names] fletxa-right-16] == -1 } {
	    image create photo fletxa-right-16 -data {
		R0lGODdhEAAQAMQAAMPIuI6ZfbW+qMvXurbHoqu7mZ+whpepfbbEoaKzjaW3jqS0iqCwhput
		fJWndaS0i5ytfJaocf//////////////////////////////////////////////////////
		/ywAAAAAEAAQAAAFryAABuJIkkIADqJIEGAhisYRBAOSKMpiMAzDNI4TBAOSKMoDMqIIRU4Q
		DEiiKNIoQpETBAOSKJIkjQzYOE4QDEiiKJIkMQwDRU4QDEiiKIskSSDDNI4TBAOSKMpiSJLE
		NI4TBAOSKMoigZLEMI3jBMGAJIoiSRLDMI3jBMGAJIoEShLDMAwUOUEwIImiSCAjilDkBMGA
		JIqyGCPTOE4QgIMoEgRYiKJxBAAYiCNJCiEAOw==
	    }
	}
    }
}

snit::widget cu::dater_entry {
    option -date ""
    option -font
    option -topframecolor

    hulltype frame

    variable entry

    delegate method * to entry
    delegate option * to entry

    constructor args {

	$self create_images

	set entry [ttk::entry $win.e -textvariable [myvar options(-date)]]
	ttk::button $win.b -image date-16 -style Toolbutton \
	    -command [mymethod post_dater]

	bindtags $entry [concat $win [bindtags $entry]]

	grid $entry $win.b -sticky w
	grid configure $entry -sticky ew
	grid columnconfigure $win 0 -weight 1

	$self configurelist $args

	bind $win <FocusIn> [list focus $entry]
    }
    onconfigure -date { value } {
	set options(-date) $value

	$entry delete 0 end
	$entry insert end $value
    }
    oncget -date {
	set options(-date) [$entry get]
	return $options(-date)
    }
    method post_dater {} {
	destroy $win.dt
	set post_dater [toplevel $win.dt -bd 1 -relief solid]
	wm withdraw $win.dt
	wm overrideredirect $win.dt 1
	set h [expr {[winfo rooty $win.e]+[winfo height $win.e]}]
	cu::dater $win.dt.d -date [$self cget -date] -select_handler \
	    [mymethod end_post_dater $win.dt] -grab 1
	if { [info exists options(-font)] } {
	    $win.dt.d configure -font $options(-font)
	}
	if { $options(-topframecolor) ne "" } {
	    $win.dt.d configure -topframecolor $options(-topframecolor)
	}
	grid $win.dt.d
	wm geometry $win.dt +[winfo rootx $win.e]+$h
	update idletasks
	wm deiconify $win.dt
    }
    method end_post_dater { w date } {
	if { $date ne "" } {
	    $self configure -date $date
	}
	destroy $w
    }
    method create_images {} {
	if { [lsearch [image names] date-16] == -1 } {
	    image create photo date-16 -data {
		R0lGODlhEAAQAIQAAASC/AQCBPzerPyqXMRaBIQCBISChPz+/KSipMTCxPz+
		BMTCBPwCBPz+xPzCxMQCBISCBAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
		AAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAVxICCOQGCe
		JjkGwkC8RFEEavkax2G8dB0QuRyhhzoBg8MSYsncJXKJZIDZHCoWP1ogGIwG
		rtnSgUFmHLyNRHhrdpjRamnO/SYkromHdnxwnwkKVxByZW8DgQsQM2JcfwZX
		O0MBCZSVBgMuLzJaRZ0pfiEAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQcm8g
		dmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmlnaHRz
		IHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
	    }
	}
    }

}

################################################################################
#    icons
################################################################################

# program_name is to store a copy of the database (if necessary) in a program
# dependent dir

namespace eval cu {
    variable icons_lib_db
}
namespace eval cu::icons {}

proc cu::init_icons_lib { dbfile program_name } {
    variable icons_lib_db

    set dbfile [file normalize $dbfile]
    if { [lindex [file system $dbfile] 0] ne "native" } {
	set nfile [file join [cu::file::appdatadir $program_name] \
		[file tail $dbfile]]
	if { ![file exists $nfile] || [file mtime $nfile] < [file mtime $dbfile] } {
	    file copy -force $dbfile $nfile
	}
	set dbfile $nfile
    }
    package require sqlite3

    set idx 1
    while { [info command ::cu::icons_lib_db$idx] ne "" } { incr idx }
    set icons_lib_db ::cu::icons_lib_db$idx
    sqlite3 $icons_lib_db $dbfile
}

proc cu::is_icons_lib_init {} {
    variable icons_lib_db
    return [info exists icons_lib_db]
}

proc cu::get_icon { icon_name } {
    variable icons_lib_db

    if { [info command ::cu::icons::$icon_name] ne "" } {
	return ::cu::icons::$icon_name
    }
    set data [$icons_lib_db onecolumn { select data from icons
	    where name=$icon_name }]
    image create photo ::cu::icons::$icon_name -data $data
    return ::cu::icons::$icon_name
}

if 0 {
    package require msgcat
    package require compass_utils
    #pack [cu::dater_entry .d -topframecolor red]
    
    proc give_events { start_date end_date } {
	return [dict create \
		2006-09-05 [list [dict create text "Hola maco" start 8:30 end 9:30] \
		    [dict create text "Hola maco2" start 8:30 end 9:30]] \
		2006-09-12 [list [dict create text "cita 2" start 12:30 end 3:30]]]
    }
    
    pack [cu::dater .d -events_handler give_events -detailed_view 0] -fill both \
	-expand 1
}










